/***
 * midistuff.h
 *
 *			Make sounds from the debugger over midi
 *
 *		by Bernie Bernstein for and entirely during MacHack '93 (June 16-18)
 ***/


/*** uncomment the one that you need or do the define from somewhere else ***/

/* SONICAPP if you are linking this to an application */
//#define SONICAPP

/* SONICDCMD if you are building the dcmd */
//#define SONICDCMD

/* SONICINIT if you are building the init */
//#define SONICINIT


/* Resource ID */



/* MIDI constants */

#define kStartSignature		'SNDA'
#define kEndSignature		'SNDZ'
#define kMaxClients			16
#define refCon0				0L
#define outputPortBuffSize	300

//#define outputPortID		'Aout'
//#define inputPortID		'Bin '

//#define inputPortID		'Bin '
//#define outputPortID		'Cout'

#define inputPortID			'in  '
#define outputPortID		'out '


#define errNoMIDIManager	-26002
#define	kIconSize			256
#define kIconID				8888

typedef struct SonicGlobs
	{
	Boolean		soundEnabled;
	Boolean		manualPatch;
	short		outputRefNum;
	OSErr		clientID;
	Handle		iconHdl;
	Boolean		gotIcon;
	}
SonicGlobs, *SonicGlobPtr;



/* midiplayer.c */
#ifdef SONICDCMD
pascal void CommandEntry(dcmdBlock *paramPtr);
#endif
void LoadIcon(void);
void PreInitMidi(void);
void InitMidi(void);
void KillMidi(void);
OSErr MIDIManagerSignup(void);
OSErr MIDIManagerConnect(void);
OSErr StartNote(char channel, char pitch, char velocity);
OSErr StopNote(char channel, char pitch);
OSErr SetPanPot(char channel, char position);
OSErr SetProgramChannel(char channel, char voice);
OSErr SilenceAll(void);
char *Pstrcat(register unsigned char *, register unsigned char *);
char *Pstrcpy(register unsigned char *, register unsigned char *);
short Pstrcmp(register Str255, register Str255);
