/******************************************************************************

	FILE:
		InfinityWindoid.h
		
	DESCRIPTION:
		This file contains headers that can be used by an application using
		the Infinity Windoid WDEF.

		In order to create a window using the Infinity Windoid WDEF, the
		following constants, defined here, are useful:
			kInfinityWindoidProc
			kVerticalTitlebarProc
			zoomDocProc				(defined in Windows.h)

		For instance, if you want a new windoid with the titlebar down the
		left side of the window and no zoom box:

			theWindow = NewWindow( &storage, bounds, title, visible, 
								   kInfinityWindoidProc + kVerticalTitlebarProc, 
								   behind, goAwayFlag, refCon );

		The goAwayFlag will determine if the windoid has a close box.
		If a zoom box is desired, just add zoomDocProc to theProc.

******************************************************************************/

#define kInfinityWindoidProc	(128 * 16)
	//	if you change the ID of the WDEF that is created, change the 128 to
	//	the new ID.

#define kVerticalTitlebarProc	2

